// GenericMethodsAndOverloadingCpp.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>

template<typename T>
void m(T t) {
	std::cout << "m(" << typeid(T).name() << ") method template\n";
}

void m(int i) {
	std::cout << "m(int) !!!!! method overload !!!!!\n";
}

template<typename T>
void CallM(T t) {
	std::cout << "CallM(" << typeid(T).name() << ") method template calling: ";
	m(t);
}

int main()
{
    std::cout << "In C++:\n";
	
	m("Hello");
	m(3.14);
	m(10);

	std::cout << "---\n";

	CallM("Hello");
	CallM(3.14);
	CallM(10);
}