#include <iostream>

class A {
public:
	void m(int x) { std::cout << "A::m(int) called ***\n"; }

	bool operator <(const A& d) {
		std::cout << "[A::< called]";
		return true;
	}
};

class B {
public:
	void m(float x) { std::cout << "B::m(float) called +++\n"; }
};

template<typename T>
void f(T x) {
	std::cout << "f(" << typeid(T).name() << ") calling m: ";
	x.m(10);
}

template<typename T>
void Max(T a, T b) {
	std::cout << "Max(" << typeid(T).name() << ") comparision result: "
		<< (a < b) << "\n";
}

int main()
{
    std::cout << "In C++:\n";

	A a1, a2;
	B b1, b2;

	f(a1);
	f(b1);
	// f(10);

	std::cout << "---\n";

	Max(a1, a2);
	// Max(b1, b2);
	Max(10, 20);
}

