﻿using System.Globalization;

namespace IFormattableGenericConstraint {
	class Program {
	
		public static void m1(IFormattable f) {
			Console.WriteLine(f.ToString("X", CultureInfo.GetCultureInfo("cs-CZ")));
		}

		public static void m2<T>(T f) where T : IFormattable {
			Console.WriteLine(f.ToString("X", CultureInfo.GetCultureInfo("cs-CZ")));
		}

		static void Main(string[] args) {
			m1(254);
			m2(254);

			Console.WriteLine();

			m1(254L);
			m2(254L);
		}
	}
}