﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

class C<T> {
	public void m(T t) { Console.WriteLine($"T = {typeof(T)}"); }
	public void m(int i) { Console.WriteLine("int"); }
	public void m<U>(U u) { Console.WriteLine($"U = {typeof(U)}"); }
}

class Program {
	static void Main(string[] args) {
		Console.WriteLine("C<long>:");

		C<long> c1 = new C<long>();
		c1.m(1);
		c1.m(1L);
		c1.m((byte) 1);

		Console.WriteLine("\nC<int>:");

		C<int> c2 = new C<int>();

		Console.WriteLine("Test: 1, 1L, (byte) 1");
		c2.m(1);
		c2.m(1L);
		c2.m((byte) 1);

		Console.WriteLine("\nTest: 2, t:2, u:2");
		c2.m(2);
		c2.m(t: 2);
		c2.m(u: 2);
	}
}
